﻿import std.cstream;
import hdk.wrlayers;
import hdk.math;
import hdk.sdlbase;

int main()
{
	try
	{
		auto WrLayer7 wnd = new WrLayer7();
		while (wnd.doEvents())
		{
			alias Vector.create rgba;
			alias Matrix.translation translation;
			alias Matrix.scaling scaling;
			const dchar[] TEXTURE0 = `..\resource\test0.png`;
			const dchar[] TEXTURE1 = `..\resource\test1.png`;
			
			wnd.modelView = translation(-0.5, 0.5, 0);
			wnd.drawRectangle(rgba(1.0, 0.5, 0.5, 0.5));
			
			wnd.modelView = translation(0.5, 0.5, 0);
			wnd.drawTexture(TEXTURE0, rgba(1.0, 1.0, 1.0, 1.0));
			
			wnd.modelView = scaling(1.0, 32.0 / 512.0, 1.0) * translation(-0.5, -0.5, 0);
			wnd.drawText("AAAAAAAAAA", rgba(1.0, 1.0, 1.0, 1.0));
			
			// texture_blend.vert texture_blend.frag
			wnd.modelView = translation(0.5, -0.5, 0);
			wnd.setShaderInt("texture_blend", "texture0", 0);
			wnd.setShaderInt("texture_blend", "texture1", 1);
			wnd.setShaderInt("texture_blend", "texture2", 2);
			wnd.setShaderInt("texture_blend", "texture3", 3);
			wnd.drawPcnt("texture_blend", "defaultRectangleVertex",
				TEXTURE0, TEXTURE1, "AAAAAAAAAA", "__________あああああ");
			
			sleep(15);
		}
		dout.writeLine("ok");
	}
	catch (Exception e)
	{
		derr.writeLine("Exception: " ~ e.toString());
	}
	return 0;
}
